package com.vcarecity.publish.elastic.service.impl;

import com.vcarecity.publish.elastic.service.ElasticQueryService;
import lombok.extern.slf4j.Slf4j;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.TermQueryBuilder;
import org.elasticsearch.search.SearchHit;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.IOException;

/**
 * @author VcKerry on 12/17/19
 */

@Slf4j
@Service
public class ElasticQueryServiceImpl implements ElasticQueryService {

    private final RestHighLevelClient restHighLevelClient;


    @Value("${app.index.name}")
    private String indexName;

    public ElasticQueryServiceImpl(RestHighLevelClient restHighLevelClient) {

        this.restHighLevelClient = restHighLevelClient;
    }

    @Override
    public void testQuery() throws IOException {

        TermQueryBuilder unitId = QueryBuilders.termQuery("unitId", 39746);


        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder();
        searchSourceBuilder.query(unitId);


        SearchRequest request = new SearchRequest(indexName);
        request.source(searchSourceBuilder);

        SearchResponse response = restHighLevelClient.search(request, RequestOptions.DEFAULT);
        for (SearchHit hit : response.getHits()) {
            logger.debug("{}", hit.getSourceAsString());
        }

    }
}
