package com.vcarecity.publish.service.impl;

import com.vcarecity.publish.entity.UnitAgencyMergeEntity;
import com.vcarecity.publish.mapper.UnitMapper;
import org.elasticsearch.action.update.UpdateRequest;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.script.Script;
import org.elasticsearch.script.ScriptType;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@SpringBootTest
class UnitServiceImplTest {

    @Autowired
    private RestHighLevelClient restHighLevelClient;

    @Autowired
    private UnitMapper unitMapper;

    @Test
    public void getUnitAgencyByQuery() {

        UpdateRequest request = new UpdateRequest();

        Map<String, Object> parameters = new HashMap<>();
        parameters.put("dtuNo", "1234567890AB");
        // parameters.put("puserCode", "/0/1234567890AB/1/031号");

        Script inline = new Script(ScriptType.INLINE, "painless",
                "ctx._source.dtuNo = params.dtuNo", parameters);

        request.script(inline);
    }

    @Test
    public void loadByUnitIds() throws Exception {
        List<Long> ids = new ArrayList<>();
        ids.add(545775L);
        final List<UnitAgencyMergeEntity> unitAgencyMergeEntities = unitMapper.loadByUnitIds(ids);
        for (UnitAgencyMergeEntity unitAgencyMergeEntity : unitAgencyMergeEntities) {
            System.out.println(unitAgencyMergeEntity);
        }
    }
}